# Formality

[![npm version](https://img.shields.io/npm/v/re-formality.svg?style=flat-square)](https://www.npmjs.com/package/re-formality)
[![build status](https://github.com/MinimaHQ/re-formality/workflows/re-formality%20pipeline/badge.svg)](https://github.com/MinimaHQ/re-formality/actions)
[![license](https://img.shields.io/npm/l/re-formality.svg?style=flat-square)](https://www.npmjs.com/package/re-formality)

Form validation tool for [`@rescript/react`](https://reasonml.github.io/reason-react/).

## Features
* Validation strategies
* Async validations
* Collections
* Dependent fields
* I18n compatible

> ### ShakaCode
> If you are looking for help with the development and optimization of your project, [ShakaCode](https://www.shakacode.com) can help you to take the reliability and performance of your app to the next level.
>
> If you are a developer interested in working on ReScript / TypeScript / Rust / Ruby on Rails projects, [we're hiring](https://www.shakacode.com/career/)!

## Documentation
- [Installation](./docs/01-Installation.md)
- [Validation Strategies](./docs/02-ValidationStrategies.md)
- [IO](./docs/03-IO.md)
- [Basic Usage](./docs/04-BasicUsage.md)
- [Async Validation](./docs/05-AsyncValidation.md)
- [Collections](./docs/06-Collections.md)
- [Dependent Fields](./docs/07-DependentFields.md)
- [Metadata](./docs/08-Metadata.md)
- [Form Submission](./docs/09-FormSubmission.md)
- [I18n](./docs/10-I18n.md)
- [Caveats](./docs/11-Caveats.md)
- [API](./docs/12-API.md)

## Examples
* [Live demo](https://re-formality.now.sh)
* [Live @ minima.app](https://minima.app)
* [Sources](./examples)

## Contributing
See [CONTRIBUTING](./CONTRIBUTING.md).

## Alternatives
- [ReForm](https://github.com/Astrocoders/reform)<br>
  Alternative form state management solution for ReasonReact apps.

## License
See [LICENSE](./LICENSE).

## Supporters

<a href="https://www.jetbrains.com">
  <img src="https://user-images.githubusercontent.com/4244251/184881139-42e4076b-024b-4b30-8c60-c3cd0e758c0a.png" alt="JetBrains" height="120px">
</a>
<a href="https://scoutapp.com">
  <picture>
    <source media="(prefers-color-scheme: dark)" srcset="https://user-images.githubusercontent.com/4244251/184881147-0d077438-3978-40da-ace9-4f650d2efe2e.png">
    <source media="(prefers-color-scheme: light)" srcset="https://user-images.githubusercontent.com/4244251/184881152-9f2d8fba-88ac-4ba6-873b-22387f8711c5.png">
    <img alt="ScoutAPM" src="https://user-images.githubusercontent.com/4244251/184881152-9f2d8fba-88ac-4ba6-873b-22387f8711c5.png" height="120px">
  </picture>
</a>
<br />
<a href="https://www.browserstack.com">
  <picture>
    <source media="(prefers-color-scheme: dark)" srcset="https://user-images.githubusercontent.com/4244251/184881122-407dcc29-df78-4b20-a9ad-f597b56f6cdb.png">
    <source media="(prefers-color-scheme: light)" srcset="https://user-images.githubusercontent.com/4244251/184881129-e1edf4b7-3ae1-4ea8-9e6d-3595cf01609e.png">
    <img alt="BrowserStack" src="https://user-images.githubusercontent.com/4244251/184881129-e1edf4b7-3ae1-4ea8-9e6d-3595cf01609e.png" height="55px">
  </picture>
</a>
<a href="https://railsautoscale.com">
  <img src="https://user-images.githubusercontent.com/4244251/184881144-95c2c25c-9879-4069-864d-4e67d6ed39d2.png" alt="Rails Autoscale" height="55px">
</a>
<a href="https://www.honeybadger.io">
  <img src="https://user-images.githubusercontent.com/4244251/184881133-79ee9c3c-8165-4852-958e-31687b9536f4.png" alt="Honeybadger" height="55px">
</a>

<br />
<br />

The following companies support our open source projects, and ShakaCode uses their products!
